<template>
  <div v-if="map" class="_container">
    <h1>{{ $t('js.maps.edit.title') }}</h1>

    <!-- We don't use "rui-form" here as it's not suitable for this form -->
    <form action="#" class="gpa-map-form" @submit.prevent="save">
      <div class="-grid-1-2 -gap">
        <div>
          <rui-errors :errors="errors" model="map" />

          <fieldset>
            <legend>{{ $t('js.maps.form.groups.general') }}</legend>
            <rui-field input-id="map_name" :label="$t('activerecord.attributes.map.name')">
              <input id="map_name" v-model="inputs.name" type="text" required>
            </rui-field>

            <rui-field :help="$t('js.maps.form.publicly_available_help')">
              <label for="map_publicly_available">
                <input id="map_publicly_available"
                       v-model="inputs.publicly_available"
                       type="checkbox"
                       name="publicly_available">
                {{ $t('activerecord.attributes.map.publicly_available') }}</label>
            </rui-field>
          </fieldset>

          <fieldset class="-mtd">
            <legend>{{ $t('js.maps.form.groups.background') }}</legend>
            <rui-field>
              <label for="map_hide_background">
                <input id="map_hide_background"
                       v-model="inputs.hide_background"
                       type="checkbox"
                       name="hide_background">
                {{ $t('activerecord.attributes.map.hide_background') }}</label>
            </rui-field>

            <rui-field>
              <label for="map_toggle_background">
                <input id="map_toggle_background" type="checkbox" :checked="inputs.background_color" @change="toggleBackgroundColor">
                {{ $t('js.maps.form.custom_background_color') }}
              </label>
            </rui-field>

            <rui-field>
              <label :class="{'-text--color-mute': !inputs.background_color}">
                {{ $t('js.maps.form.pick_color') }}
                <input v-model="inputs.background_color" type="color" :disabled="!inputs.background_color">
              </label>
            </rui-field>
          </fieldset>
          <fieldset class="-mtd">
            <legend>{{ $t('js.maps.form.groups.map_scaling') }}</legend>
            <rui-alert v-if="extentChanged" variant="info">{{ $t('js.maps.form.extent_changed_note') }}</rui-alert>
            <rui-button :active="isSettingScale" :disabled="map.isOSM" block @click="setScale">
              {{ $t('js.maps.form.scale_map') }}
            </rui-button>
            <rui-field v-if="isSettingScale"
                       input-id="map-scale-reference"
                       :label="$t('js.maps.form.scale_reference')"
                       :help="$t('js.maps.form.extent_change_warning')"
                       append="m">
              <input id="map-scale-reference" v-model="scaleReference" name="scale" type="number">
            </rui-field>
          </fieldset>

          <fieldset class="-mtd">
            <legend>{{ $t('js.maps.form.groups.center_definition') }}</legend>
            <rui-alert v-if="centerChanged" variant="info">{{ $t('js.maps.form.center_changed_note') }}</rui-alert>
            <rui-button :active="isSettingCenter" block @click="setCenter">{{ $t('js.maps.form.select_center') }}</rui-button>
            <rui-alert v-if="isSettingCenter && !centerChanged" variant="info">
              {{ $t('js.maps.form.select_center_note') }}
            </rui-alert>
          </fieldset>

          <div class="-text--right -mtd">
            <rui-submit-button :loading="loading" :disabled="extentChanged && !centerChanged" />
          </div>
        </div>

        <div id="map" class="gpa-map-form__map" :style="mapStyle" />
      </div>
    </form>
  </div>
</template>

<script>
import RuiAlert from '@experiments-labs/rise_ui/src/components/Alert/Alert.vue'
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiErrors from '@experiments-labs/rise_ui/src/components/DataDisplay/Error/Errors.vue'
import RuiField from '@experiments-labs/rise_ui/src/components/Form/Field.vue'
import RuiSubmitButton from '@experiments-labs/rise_ui/src/components/Inputs/SubmitButton/SubmitButton.vue'
import MapEditionMixin from '../mixins/MapEdition'

export default {
  name: 'GpaMapForm',
  emits: [
    'saved',
  ],
  components: { RuiSubmitButton, RuiAlert, RuiButton, RuiErrors, RuiField },
  mixins: [MapEditionMixin],
  data () {
    return {
      inputs: {
        name: null,
        publicly_available: false,
        hide_background: false,
        center: [],
        background_color: null,
      },
      loading: false,
      errors: null,

      isSettingScale: false,
      isSettingCenter: false,
    }
  },
  computed: {
    map () { return this.$store.getters.map(parseInt(this.$route.params.mapId, 10)) },
    mapStyle () {
      if (!this.inputs.background_color) return ''

      return `background-color: ${this.inputs.background_color}; background-image: none;`
    },
  },
  methods: {
    setScale () {
      this.isSettingCenter = false
      this.isSettingScale = true
      this.enterMeasureMode()
    },
    setCenter () {
      this.isSettingCenter = true
      this.isSettingScale = false
      this.enterCenterSelectionMode()
    },
    toggleBackgroundColor () { this.inputs.background_color = this.inputs.background_color ? null : '#FFFFFF' },
    save () {
      const payload = {
        id: this.map.id,
        name: this.inputs.name,
        hide_background: this.inputs.hide_background,
        publicly_available: this.inputs.publicly_available,
        background_color: this.inputs.background_color,
      }
      if (this.extentChanged) {
        payload.extent_width = this.map.picture.size[0] * this.previousScale
        payload.extent_height = this.map.picture.size[1] * this.previousScale
      }
      if (this.centerChanged) {
        payload.center = this.inputs.center
      }
      this.loading = true
      this.errors = null

      this.$store.dispatch('updateMap', payload)
        .then(() => {
          this.$emit('saved')
          this.$router.push({ name: 'map', params: { mapId: this.map.id } })
        })
        .catch((errors) => { this.errors = errors })
        .then(() => { this.loading = false })
    },
  },
  created () {
    this.$nextTick(() => {
      this.inputs.name = this.map.name
      this.inputs.center = this.map.center
      this.inputs.publicly_available = this.map.publiclyAvailable
      this.inputs.background_color = this.map.backgroundColor
      const that = this
      if (this.map.isOSM) {
        this.loadOSMMap()
      } else {
        this.previousScale = this.map.extentWidth / this.map.picture.size[0]
        fetch(this.map.picture.url).then((response) => {
          const reader = new FileReader()
          response.blob().then((blob) => {
            that.loadAndRenderMap(reader)
            reader.readAsDataURL(blob)
          })
        })
      }
    })
  },
}
</script>

<style lang="scss" src="./MapForm.scss" />
